<?php


class viewAccountProfile {
    /**
     *
     * @param int $id id of the profile to display
     * @return type 
     */
    public static function displayProfile ($id){
                
        // triggers events which attach menu items to account profile menu. 
        // e.g. amessage system. 
        
        $params = array (
            'user_id' => $id, 
            'action' => 'profile_display'
        );
        
        event::getTriggerEvent(
            config::getModuleIni('account_profile_events'), 
            $params
        );
        
        
        $account = account_profile::getAccount($id);


        if (empty($account)){
            echo lang::translate('account_profile_no_such_account');
            return;
        }
        
        $account_profile = account_profile::getAccountProfile($account['id']);
        
        
        headline_message(lang::translate('account_profile_headline'));
       
        $title = lang::translate('account_profile_view_user_profile');

	if (!empty($account_profile)) {
	
           $title.= MENU_SUB_SEPARATOR;
	    if (empty($account_profile['screenname'])) {
                $title.= $account_profile['id'];
            } else {
                $title.= $account_profile['screenname'];
            }
        }
        
        //print_r($account_profile);
        template::setTitle($title);
        $str = "<table class=\"account_profile\">";
        $str.= "<tr><td rowspan =\"4\">";

        if (!config::getModuleIni('account_profile_simple')){       
            $email = $account['email'];
            $size = 120;
            $str.= html::createImage(
                       account_profile::getIdenticonImageUrl($email, config::getModuleIni('account_profile_image_size_large')),
                       array('alt' => lang::translate('account_profile_identicon_alt')));
        }

        $str.= "<td>" . lang::translate('account_profile_screenname') . MENU_SUB_SEPARATOR_SEC . "</td>";
        $str.= "<td>" . @$account_profile['screenname'] . "</td>";
        $str.= "</tr>";

        $str.= "<tr>";
        $str.= "<td>" . lang::translate('account_profile_website') . MENU_SUB_SEPARATOR_SEC . "</td>";
        $str.= "<td>" . html::createLink(@$account_profile['website'], @$account_profile['website']) . "</td>";
        $str.= "</tr>";

        $str.= "<tr>";
        $str.= "<td>" . lang::translate('account_profile_name') . MENU_SUB_SEPARATOR_SEC . "</td>\n";
        $str.= "<td>" . @$account_profile['firstname'] . " " . @$account_profile['lastname'] . "</td>\n";
        $str.= "</tr>";
        
        if (@$account_profile['birthday'] == '0000-00-00' ||
              empty($account_profile['birthday'])){
            $birthday = '';
        } else {
            $birthday = birthday($account_profile['birthday']);
        }

        $str.= "<tr>";
        $str.= "<td>" . lang::translate('account_profile_age') . "</td>\n";
        $str.= "<td>" . $birthday . "</td>\n";
        $str.= "<tr>";
        $str.= "</table>\n";

        $account_profile['description'] = html::specialDecode(@$account_profile['description']);
        $filters = config::getModuleIni('account_profile_filters');
        $account_profile['description'] = moduleLoader::getFilteredContent($filters, $account_profile['description']);

        if (!config::getModuleIni('account_profile_only_desc')) {
            echo $str;
            headline_message(lang::translate('account_profile_description'));
        }

        echo $account_profile['description'] . "\n";

        // add edit link
        if ($account['id'] == session::getUserId()){
            echo "<br />\n";
            echo lang::translate('account_profile_is_profile') . " :: ";
            echo html::createLink("/account_profile/edit/$account[id]", lang::translate('account_profile_edit_profile'));
        }
    }
}

// found on
// http://snippets.dzone.com/posts/show/1310
function birthday ($birthday)
  {
    list($year,$month,$day) = explode("-",$birthday);
    $year_diff  = date("Y") - $year;
    $month_diff = date("m") - $month;
    $day_diff   = date("d") - $day;
    if ($month_diff < 0) $year_diff--;
    elseif (($month_diff==0) && ($day_diff < 0)) $year_diff--;
    return $year_diff;
  }
