<?php

if (!session::checkAccessControl('content_allow_edit')){
    return;
}

http::prg();

moduleLoader::includeModule ('content/article');

template::setInlineJs(_COS_PATH . "/modules/content/content.js");
template::setTitle(lang::translate('content_article_edit_article_title'));

$article = new contentArticle();
$row = $article->getArticle('update');
$link = $article->getArticleHTMLLink();
$headline = lang::translate('content_article_edit_article_title') . MENU_SUB_SEPARATOR_SEC . $link;

$options = array ();
$options['js'] = array ('reference' => 'content/article', 'parent_id' => $row['id'] );
contentArticle::loadAssets($options);
headline_message($headline);

$admin_modules = config::getModuleIni('content_admin_sub_modules');
moduleLoader::includeModules($admin_modules);
$return_url = contentArticle::getArticleUrl($row['id'], $row['title']);
$return_url = html::getUrl($return_url);
        
$options = array (
    'parent_id' => $row['id'],
    'reference' => 'content/article',
    'return_url' => $return_url
);

if ($admin_modules) {
    $ary = moduleLoader::subModuleGetAdminOptions($admin_modules, $options);
    echo implode(MENU_SUB_SEPARATOR, $ary);
}

if (!empty($_POST['submit'])){
    $article->sanitize();
    $article->validate();
    if (empty($article->errors)){
        $res = $article->updateArticle();
        if ($res){
            session::setActionMessage(lang::translate('content_article_article_updated'));
            http::locationHeader($return_url);
        } else {
            view_form_errors($article->errors);
            viewContentArticle::articleForm('update', $row['id']);
        }
    } else {
        view_form_errors($article->errors);
        viewContentArticle::articleForm('update', $row['id']);
    }
} else {
    viewContentArticle::articleForm('update', $row['id']);
}
