<?php

moduleLoader::includeModel('content/article');



class contentSortmenu extends contentArticle {

    /**
     * recursive method for getting article tree from a system menu
     *
     * @param       int     id of article. Then we find parent_id and id of that ... etc
     * @return      array   str with html displaying the tree
     */
    public function getArticleBranchHTMLFromAry(&$ary, $show_branch = null){
        

    }
        


    /**
     * recursive method for getting article tree.
     *
     * @param       int     id of article. Then we find parent_id and id of that ... etc
     * @return      array   str with html displaying the tree
     */
    public function getArticleTreeHTMLFromAry($ary){
        static $str = '';


        if (!empty($ary)){
            $str.="<ul>";
        }

        foreach ($ary as $key => $val){
            $str.="<li>" .
                html::createLink(
                    "/content/article/view/$val[id]",
                    $val['title']) . "";
            if (!empty($val['sub'])){
                $this->getArticleTreeHTMLFromAry($val['sub']);
            } else {
                $str.="</li>";
            }
        }

        if (!empty($ary)) {
            $str.= "</ul>\n";
        }
        return $str;
    }

    /**
     * recursive method for getting article tree.
     *
     * @param       int     id of article. Then we find parent_id and id of that ... etc
     * @return      array   str with html displaying the tree
     */
    public function getManipTreeHTML($ary, $start = null){
        static $str = '';
        

        if ($start) {

            $str.= "<ol class=\"sortable\">\n";

        } else {
            $str.= "<ol>\n";
        }

        foreach ($ary as $val){
            // no title - item has been deleted. 
            if (empty($val['title'])) continue;
            $str.="<li id=\"list_$val[id]\">" .
                "<div>" . html::createLink(
                    "/content/article/view/$val[id]",
                    $val['title']) . "</div>";
            if (!empty($val['sub'])){
                $this->getManipTreeHTML($val['sub']);
            } else {
                //$str.="</li>\n";
            }
        }

        if (!empty($ary)) {
            $str.= "</li></ol>\n";
        }
        return $str;
    }

/**
     * recursive method for getting article tree.
     *
     * @param       int     id of article. Then we find parent_id and id of that ... etc
     * @return      array   str with html displaying the tree
     */
    public function getManipTreeHTMLFromDb($ary, $start = null){
        static $str = '';


        if ($start) {

            $str.= "<ol class=\"sortable\">\n";

        } else {
            $str.= "<ol>\n";
        }

        foreach ($ary as $val){
            $str.="<li id=\"list_$val[id]\">" .
                "<div>" . html::createLink(
                    "/content/article/view/$val[id]",
                    $val['title']) . "</div>";
            if (!empty($val['sub'])){
                $this->getManipTreeHTML($val['sub']);
            } else {
                //$str.="</li>\n";
            }
        }

        if (!empty($ary)) {
            $str.= "</li></ol>\n";
        }
        return $str;
    }

    public function generateTreeFromAry ($input_ary){

        $list = array();
        foreach ($input_ary as $key => $val){
            $art = $this->getArticleFromId($key);
            
            if ($val == 'root'){
                $list[] = array (
                    'id' => $key,
                    'pid' => 0,
                    'title' => $art['title']);
            } else {
                $list[] = array (
                    'id' => $key,
                    'pid' => $val,
                    'title' => $art['title']);
            }
        }

        //$list = $ary;
        $lookup = array();
        foreach( $list as $item ) {
            $item['sub'] = array();
            $lookup[$item['id']] = $item;
        }

        $tree = array();
        foreach( $lookup as $id => $foo ){
            $item = &$lookup[$id];
            if( $item['pid'] == 0 ){
                $tree[$id] = &$item;
            } else {
                if( isset( $lookup[$item['pid']] ) ) {
                    $lookup[$item['pid']]['sub'][$id] = &$item;
                } else {
                    $tree['_orphans_'][$id] = &$item;
                }
            }
        }

        return $tree;
    }

    public function updateSystemMenu($values, $name){

        $row = $this->selectOne('system_menu', 'name', $name);
        if (empty($row)){
            $values ['name'] = $name;
            $this->insert('system_menu' , $values);
        } else {
            $this->update('system_menu', $values, $row['id']);
        }
    }

    public function getArticleSystemMenu ($name){
        $row = $this->selectOne('system_menu', 'name', $name);
        if (empty($row)){
            return null;
        }
        return $row;
    }
}