<?php

/**
 * include some css
 */
template::setInlineCss(config::getModulePath('jquerysort') . '/jquerysort.css');

/**
 * class for sorting any table with jquery 
 * @package jquerysort
 */
class jquerysort {

    /**
     * options
     * @var array $options 
     */
    public static $options = null;
    
    public function __construct($options = null) {
        self::$options = $options;
    }
    
    /**
     * method for settings options
     * @param array $options the following options are possible
     *              array ('table' => 'the db table to sort', 
     *                     'title' => 'the db field to display as title',
     *                     'field' => 'the db field to sort - INT,
     *                     'where_sql' => '`parent` = 3'
     *                     'items' => 'you can supply the items to sort as an array',
     *                     'translate => 'if this is set the titles will be translated'
     *              );         
     */
    public static function setOptions ($options) {
        self::$options = $options;
    }

    /**
     * display jquery sorting of categories. 
     * @return  string $str the sorting html
     */
    public static function getHTML(){

        if (!isset(self::$options['items'])) {
            dbQ::setSelect(self::$options['table']);
            if (isset(self::$options['where_sql'])) {
                dbQ::sql(self::$options['where_sql']);
            }
            
            dbQ::order(self::$options['field'], 'ASC');
            $items = dbQ::fetch();
        } else {
            $items = self::$options['items'];
        }


        $str = '';
        $str.= "<div id=\"jquerysort_response\"></div>";
        $str.= "<ul id=\"jquerysort_list\">\n";
        foreach ($items as $key => $val){
            //$text = strings::toUTF8($val[self::$options['title']]);  
            $text = $val[self::$options['title']];
            $id = "arrayorder_$val[id]";
            if (isset(self::$options['function'])) {
                $func = self::$options['function'];
                $text = $func($val['id'], $text);
            }
            
            
            $str.= "<li id = \"$id\">" . $text;
            $str.= "</li><div class=\"clear\"></div>";
        }
        $str.= "</ul>\n";
        
        return $str;
    }
    
    /**
     * method for setting the jquery sorting javascript
     */
    public static function setJs(){
        $search = array(
            'jquerysort_table_replace', 
            'jquerysort_field_replace',
            'jquerysort_title_replace');
        $replace = array(
            self::$options['table'], 
            self::$options['field'], 
            self::$options['title']);

        $sort_js = config::getModulePath ('jquerysort') . "/sort.js";                  
        template::setInlineJs(
            $sort_js, 
            // load last or close to. 
            null,
            array ('no_cache' => 1, 'search' => $search, 'replace' => $replace)
        );         
    }
}
