<?php

template::setInlineCss(config::getModulePath('system') . "/assets/dropdown.css");
template::setInlineJs(config::getModulePath('system') . "/assets/dropdown.js");

class systemMenu {
       
    public static function getAdminMenuAsSections () {
         $menus = layout::$menu['admin'];
         
         $sections = array ();         
         foreach ($menus as $key => $val) {
             $section = $val['section'];
             $sections[$section][] = $val;                         
         }    
         return $sections;
    }
    
    public static function getAllMenuAsSections () {
        $main = layout::$menu['main'];
        $sections['main'] = $main;
        $sections+= self::getAdminMenuAsSections();
        
        
        return $sections;
    }
    
    public static function getSectionsForDropdown () {
        $sections = self::getAllMenuAsSections();
        $ary = array();
        $i = 1;
        foreach ($sections as $key => $val) {
            $ary[] = array ('id' => $key, 'title' => lang::translate($key));
            $i++;
        }
        return $ary;
    }
    
    public static function getAdminMenu () {        
        $sections = self::getAdminMenuAsSections();


        $menu = '';
        $menu = "<ul class=\"system_admin_menu_dropdown\">\n";
        if (isset($sections['settings'])) {            
            $menu.= "<li>" . lang::translate('system_admin_menu_section_settings');
            $menu.= self::parseSection('settings', $sections['settings']);
            $menu.= "</li>\n";
        }
        
        if (isset($sections['account'])) {            
            $menu.= "<li>\n"  . lang::translate('system_admin_menu_section_account');
            $menu.= self::parseSection('account', $sections['account']);
            $menu.= "</li>\n";
        }
        
        if (isset($sections['content'])) {            
            $menu.= "<li>\n"  . lang::translate('system_admin_menu_section_content');
            $menu.= self::parseSection('content', $sections['content']);
            $menu.= "</li>\n";
        }
        
        if (isset($sections['system'])) {            
            $menu.= "<li>\n"  . lang::translate('system_admin_menu_section_system');
            $menu.= self::parseSection('system', $sections['system']);
            $menu.= "</li>\n";
        }

        $menu.= "</ul>\n";
        return  $menu;
    }
    
    public static function getMainItems () {
        
    }
    
    
    public static function parseSection ($title, $section = array()) {
        //print_r($section);
        $str = "<ul class=\"sub_menu\">";
        //$str.= "<li>" . lang::translate("system_$title") . "</li>" . MENU_SUB_SEPARATOR_SEC;
        $str.= layout::parseAdminMenuList(array('menu' => $section));
        $str.= '</ul>';
        return $str;
    }
}