<?php

class systemModules {
    
    /**
     * method for getting 'extra modules' module which can be installed
     * or uninstalled 
     * @return array $modules modules
     */
    static function getModulesExtra () {
        return config::getModuleIni('system_modules_extra');
    }   
    
    /**
     * display form for installing removing modules 
     */
    function displayModules () {
        $extras = self::getModulesExtra();
        if (!$extras) return;
        $installed = moduleLoader::getInstalledModuleNames();
        $form= new html();
        $form->formStart('system_modules');
        $form->init(null, 'submit');
        $form->legend(lang::translate('system_modules_legend'));
        
        $options = array (
            1 => lang::translate('system_module_installed'), 
            2 => lang::translate('system_module_not_installed')); 
        
        foreach ($extras as $val) {    
            $form->label($val, $val);
            if (in_array($val, $installed)) {
                $form->radio($val, $options, 1);
            } else {
                $form->radio($val, $options, 2);
            }
        }
        
        $form->submit('submit', lang::system('update'));
        $form->formEnd();
        echo $form->getStr();
    }
}
